<?php
return  array(
    'columns'=>array(
        'shop_id'=>array(
            'type'=>'number',
            //'pkey'=>true,
            'autoincrement' => true,
            'required' => true,
            'label' => 'id',
            'comment' => app::get('sysshop')->_('店铺编号id 自增'),
            'order' => 1,
        ),
        'shop_name'=>array(
            //'type'=>'varchar(50)',
            'type' => 'string',
            'length' => 50,
            'required'=>true,
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('店铺名称'),
            'comment' => app::get('sysshop')->_('店铺名称'),
            'order' => 5,
        ),
        'shop_descript'=>array(
            'type'=>'text',
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('店铺描述'),
            'comment' => app::get('sysshop')->_('店铺描述'),
            'order' => 14,
        ),
        'shop_type'=>array(
            'type'=>array(
                'flag'=>'品牌旗舰店',
                'brand'=>'品牌专卖店',
                'cat'=>'类目专营店',
                'self'=>'运营商自营店铺',
                'store'=>'多品类通用型店铺',
            ),
            'required'=>true,
            'in_list'=>true,
            'default_in_list'=>true,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('店铺类型'),
            'comment' => app::get('sysshop')->_('店铺类型'),
            'order' => 6,
        ),
        'seller_id'=>array(
            'type'=>'table:account@sysshop',
            'required'=>true,
            'in_list'=>true,
            'default_in_list'=>true,
            'label' => app::get('sysshop')->_('店铺超级管理员'),
            'comment' => app::get('sysshop')->_('提交申请时的用户'),
            'order' => 7,
        ),
        'status'=>array(
            'type'=>array(
                'active'=>app::get('sysshop')->_('活动店铺'),
                'dead'=>app::get('sysshop')->_('过期店铺'),
            ),
            'default'=>'active',
            'in_list'=>true,
            'default_in_list'=>true,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('店铺状态'),
            'comment' => app::get('sysshop')->_('提交状态'),
            'order' => 8,
        ),
        'open_time'=>array(
            'type'=>'time',
            'in_list'=>true,
            'default_in_list'=>true,
            'required'=>true,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('开店时间'),
            'comment' => app::get('sysshop')->_('开店时间'),
            'order' => 9,
        ),
        'close_time'=>array(
            'type'=>'time',
            'in_list'=>true,
            'default_in_list'=>true,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('关店时间'),
            'comment' => app::get('sysshop')->_('关店时间'),
            'order' => 9,
        ),
        'close_reason' => array(
            //'type' => 'varchar(500)',
            'type' => 'string',
            'length' => 500,
            'in_list'=>true,
            'default_in_list'=>true,
            'label' => app::get('sysshop')->_('店铺关闭原因'),
            'comment' => app::get('sysshop')->_('店铺关闭原因'),
        ),
        'shop_logo'=>array(
            //'type'=>'varchar(500)',
            'type' => 'string',
            'label' => app::get('sysshop')->_('店铺logo'),
            'comment' => app::get('sysshop')->_('提交logo'),
            'in_list'=>true,
            'default_in_list'=>false,
            'order' => 10,
        ),
        'shopuser_name'=>array(
            //'type'=>'varchar(20)',
            'type' => 'string',
            'length' => 20,
            'required'=>true,
            'searchtype' => 'has',
            'filtertype' => false,
            'filterdefault' => 'true',
            'in_list' => true,
            'default_in_list' => true,
            'label' => app::get('sysshop')->_('店主姓名'),
            'comment' => app::get('sysshop')->_('店主姓名'),
            'order' => 11,
        ),
        'qq'=> array(
            'type' => 'string',
            'comment' => app::get('sysshop')->_('即时通讯qq账号配置'),
        ),
        'wangwang'=> array(
            'type' => 'string',
            'comment' => app::get('sysshop')->_('即时通讯wangwang账号配置'),
        ),
        'email'=>array(
            //'type'=>'varchar(200)',
            'type' => 'string',
            'length' => 200,
            'in_list'=>true,
            'default_in_list'=>false,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('邮箱'),
            'comment' => app::get('sysshop')->_('邮箱'),
            'order' => 12,
        ),
        'mobile'=>array(
            //'type'=>'varchar(50)',
            'type' => 'string',
            'length' => 50,
            'required'=>true,
            'in_list'=>true,
            'default_in_list'=>false,
            'filtertype' => false,
            'filterdefault' => 'true',
            'label' => app::get('sysshop')->_('手机号'),
            'comment' => app::get('sysshop')->_('手机号'),
            'order' => 13,
        ),
        'shopuser_identity'=>array(
            //'type'=>'char(18)',
            'type' => 'string',
            'length' => 18,
            'fixed' => true,
            'label' => app::get('sysshop')->_('店主身份证号'),
            'comment' => app::get('sysshop')->_('店主身份证号'),
        ),
        'shopuser_identity_img'=>array(
            //'type'=>'varchar(32)',
            'type' => 'string',
            'label' => app::get('sysshop')->_('店主身份证电子版'),
            'comment' => app::get('sysshop')->_('店主身份证电子版'),
        ),
        'shop_area'=>array(
            'type'=>'region',
            'label' => app::get('sysshop')->_('店铺所在地区'),
            'comment' => app::get('sysshop')->_('店铺所在地区'),
        ),
        'shop_addr'=>array(
            'type'=>'text',
            'required'=>true,
            'label' => app::get('sysshop')->_('店铺所在地址'),
            'comment' => app::get('sysshop')->_('店铺所在地址'),
        ),
        'bulletin'=>array(
            //'type'=>'varchar(50)',
            'type' => 'string',
            'length' => 50,
            'label' => app::get('sysshop')->_('店铺公告'),
            'comment' => app::get('sysshop')->_('店铺公告'),
        ),
    ),
    'primary' => 'shop_id',
    'index' => array(
        'ind_seller_id' => ['columns' => ['seller_id']],
        'ind_shop_type' => ['columns' => ['shop_type']],
        'ind_shop_name' => ['columns' => ['shop_name']],
    ),
    'comment' => app::get('sysshop')->_('店铺表'),

);

